
class ChristmasLights extends Mutator config(goChristmasLights);

#exec TEXTURE IMPORT NAME=Cyan 		FILE=TEXTURES\Cyan.bmp
#exec TEXTURE IMPORT NAME=Magenta 	FILE=TEXTURES\Magenta.bmp
#exec TEXTURE IMPORT NAME=Orange 	FILE=TEXTURES\Orange.bmp
#exec TEXTURE IMPORT NAME=Purple 	FILE=TEXTURES\Purple.bmp
#exec TEXTURE IMPORT NAME=Red 		FILE=Textures\Red.bmp
#exec TEXTURE IMPORT NAME=Blue 		FILE=Textures\Blue.bmp
#exec TEXTURE IMPORT NAME=Green 		FILE=Textures\Green.bmp
#exec TEXTURE IMPORT NAME=Yellow 	FILE=Textures\Yellow.bmp
#exec TEXTURE IMPORT NAME=BlueA 		FILE=Textures\BlueA.bmp
#exec TEXTURE IMPORT NAME=RedA 		FILE=Textures\RedA.bmp
#exec TEXTURE IMPORT NAME=GreenA 	FILE=Textures\GreenA.bmp
#exec TEXTURE IMPORT NAME=Gold 		FILE=Textures\Gold.bmp
#exec TEXTURE IMPORT NAME=Black 		FILE=Textures\Black.bmp
#exec TEXTURE IMPORT NAME=White 		FILE=Textures\White.bmp
#exec TEXTURE IMPORT NAME=PurpleA 	FILE=Textures\PurpleA.bmp
#exec TEXTURE IMPORT NAME=Brown 		FILE=Textures\Brown.bmp
#exec TEXTURE IMPORT NAME=Button 	FILE=Textures\Button.bmp
#exec TEXTURE IMPORT NAME=HatDeco 	FILE=Textures\Hatdeco.bmp
#exec TEXTURE IMPORT NAME=InvisDeco FILE=Textures\Invisdeco.bmp
#exec TEXTURE IMPORT NAME=DrumDeco1 FILE=Textures\Drumdeco1.bmp
#exec TEXTURE IMPORT NAME=DrumDeco2 FILE=Textures\Drumdeco2.bmp

var config bool UseLights, SpawnAtInventoryOnly, UseItemReplacements, UseChristmasTitan, UseSnowTitan, UseBothTitans;
var config float lightSize;
var config int LightHeight;
var private ChristmasLights instance;
var int VialCount, MedCount;

function PreBeginPlay()
{
	local int numColour;
	local NavigationPoint NP;
	local goTranslocGlow TG;
	local vector hitLocation;

	if(instance == none)
	   instance = self;
	else
	{
		log("Mutator is already loaded.",'ChristmasLights');
		return;
	}
	Super.PreBeginPlay();
	log("Mutator active.",'ChristmasLights');

	if(UseLights)
	{
		for(NP=Level.NavigationPointList; NP!=None; NP=NP.NextNavigationPoint)
		{
			if(SpawnAtInventoryOnly)
			{
 				if (!NP.IsA('InventorySpot'))
					continue;
			}
			numColour = rand(8) + 1;
			hitLocation = NP.Location;

			switch (numColour)
			{
  				case 1:
				TG = Spawn(class'goTranslocGlow',,,hitLocation += LightHeight * vect(0,0,1),);
				break;

				case 2:
				TG = Spawn(class'goTranslocGreen',,,hitLocation += LightHeight * vect(0,0,1),);
				break;

				case 3:
				TG = Spawn(class'goTranslocBlue',,,hitLocation += LightHeight * vect(0,0,1),);
				break;

				case 4:
				TG = Spawn(class'goTranslocGold',,,hitLocation += LightHeight * vect(0,0,1),);
				break;
				
				case 5:
				TG = Spawn(class'goTranslocCyan',,,hitLocation += LightHeight * vect(0,0,1),);
				break;
				
				case 6:
				TG = Spawn(class'goTranslocMagenta',,,hitLocation += LightHeight * vect(0,0,1),);
				break;
				
				case 7:
				TG = Spawn(class'goTranslocOrange',,,hitLocation += LightHeight * vect(0,0,1),);
				break;

				case 8:
				TG = Spawn(class'goTranslocPurple',,,hitLocation += LightHeight * vect(0,0,1),);
				break;

				default:
				log("Invalid value for numColor: " @ numColour,'ChristmasLights');
			}

			if(TG == none)
				log("Unable to spawn glowing light!",'ChristmasLights');
			else
			{
				TG.DrawScale = lightSize;
				TG.LightEffect = LE_SlowWave;
				TG.LightRadius = 10;
				TG.LightType = LT_Steady;
				TG.LightSaturation = 0;
				TG.LightBrightness = 255;

				if(TG.IsA('goTranslocGreen'))
					TG.LightHue=80;
				else if(TG.IsA('goTranslocBlue'))
					TG.LightHue=170;
				else if(TG.IsA('goTranslocGold'))
					TG.LightHue=32;
				else if(TG.IsA('goTranslocCyan'))
					TG.LightHue=127;
				else if(TG.IsA('goTranslocMagenta'))
					TG.LightHue=229;
				else if(TG.IsA('goTranslocOrange'))
					TG.LightHue=20;
				else if(TG.IsA('goTranslocPurple'))
					TG.LightHue=190;
				else
					TG.LightHue=0;
			}
		}
	}
}

function PostBeginPlay ()
{
  SetTimer(1.31,False);
}

function Timer ()
{
	local Titan T;
	local SnowTitan ST;
	local ChristmasTitan CT;

	if (UseChristmasTitan)
	{
		foreach AllActors(Class'Titan',T)
  		{
    		if ((T != None) && (T.Class==Class'Titan'))
    		{
      		T.SetCollision(False,False,False);
				CT = Spawn(Class'ChristmasTitan',,,T.Location,T.Rotation);
        		CT.Tag = T.Tag;
        		CT.Drawscale = T.Drawscale;
        		CT.Health = T.Health;
        		CT.Event = T.Event;
        		CT.FirstHatePlayerEvent = T.FirstHatePlayerEvent;
        		CT.TeamTag = T.TeamTag;
        		CT.AttachTag = T.AttachTag;
        		CT.Orders = T.Orders;
        		CT.OrderTag = T.OrderTag;
        		CT.DropWhenKilled = T.DropWhenKilled;
        		T.Destroy();
   		}
   	}
	}
	if (UseSnowTitan)
	{
		foreach AllActors(Class'Titan',T)
  		{
    		if ((T != None) && (T.Class==Class'Titan'))
    		{
      		T.SetCollision(False,False,False);
				ST = Spawn(Class'SnowTitan',,,T.Location,T.Rotation);
        		ST.Tag = T.Tag;
        		ST.Drawscale = T.Drawscale;
        		ST.Health = T.Health;
        		ST.Event = T.Event;
        		ST.FirstHatePlayerEvent = T.FirstHatePlayerEvent;
        		ST.TeamTag = T.TeamTag;
        		ST.AttachTag = T.AttachTag;
        		ST.Orders = T.Orders;
        		ST.OrderTag = T.OrderTag;
        		ST.DropWhenKilled = T.DropWhenKilled;
        		T.Destroy();
   		}
   	}
	}
	if (UseBothTitans)
	{
		foreach AllActors(Class'Titan',T)
  		{
    		if ((T != None) && (T.Class==Class'Titan'))
    		{
      		T.SetCollision(False,False,False);
				if (FRand() < 0.5)
				{
					CT = Spawn(Class'ChristmasTitan',,,T.Location,T.Rotation);
        			CT.Tag = T.Tag;
        			CT.Drawscale = T.Drawscale;
        			CT.Health = T.Health;
        			CT.Event = T.Event;
        			CT.FirstHatePlayerEvent = T.FirstHatePlayerEvent;
        			CT.TeamTag = T.TeamTag;
        			CT.AttachTag = T.AttachTag;
        			CT.Orders = T.Orders;
        			CT.OrderTag = T.OrderTag;
        			CT.DropWhenKilled = T.DropWhenKilled;
        			T.Destroy();
        		}
        		else
        		{
					ST = Spawn(Class'SnowTitan',,,T.Location,T.Rotation);
        			ST.Tag = T.Tag;
        			ST.Drawscale = T.Drawscale;
        			ST.Health = T.Health;
        			ST.Event = T.Event;
        			ST.FirstHatePlayerEvent = T.FirstHatePlayerEvent;
        			ST.TeamTag = T.TeamTag;
        			ST.AttachTag = T.AttachTag;
        			ST.Orders = T.Orders;
        			ST.OrderTag = T.OrderTag;
        			ST.DropWhenKilled = T.DropWhenKilled;
        			T.Destroy();
        		}
        	}
      }
   }
}

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	if(UseItemReplacements)
	{
		if(Other.Class==Class'SuperHealth')
		{
   		ReplaceWith(Other,"goChristmasLights.XmasHealthPack");
   		return false;
		}
		if(Other.Class==Class'Health')
		{
			if (MedCount == 0)
   		{
      		ReplaceWith(Other,"goChristmasLights.XmasMedBoxBlue");
      		MedCount = 1;
      		return false;
   		}
			else if (MedCount == 1)
			{
      		ReplaceWith(Other,"goChristmasLights.XmasMedBoxGold");
				MedCount = 2;
      		return false;
			}
			else if (MedCount == 2)
			{
      		ReplaceWith(Other,"goChristmasLights.XmasMedBoxGreen");
				MedCount = 3;
      		return false;
			}
			else if (MedCount == 3)
			{
      		ReplaceWith(Other,"goChristmasLights.XmasMedBoxRed");
				MedCount = 0;
      		return false;
			}
		}
		if(Other.Class==Class'Bandages')
		{
   		if (VialCount == 0)
   		{
      		ReplaceWith(Other,"goChristmasLights.XmasVialBlue");
      		VialCount = 1;
				return false;
			}
			else if (VialCount == 1)
			{
      		ReplaceWith(Other,"goChristmasLights.XmasVialGold");
      		VialCount = 2;
				return false;
			}
			else if (VialCount == 2)
			{
      		ReplaceWith(Other,"goChristmasLights.XmasVialGreen");
      		VialCount = 3;
				return false;
			}
			else if (VialCount == 3)
			{
      		ReplaceWith(Other,"goChristmasLights.XmasVialRed");
      		VialCount = 0;
				return false;
			}
		}
		if(Other.Class==Class'ShieldBelt')
		{
   		ReplaceWith(Other,"goChristmasLights.XmasShieldBelt");
   		return false;
		}
		if(Other.Class==Class'PowerShield')
		{
   		ReplaceWith(Other,"goChristmasLights.XmasShieldBelt");
   		return false;
		}
		if(Other.Class==Class'Armor')
		{
   		ReplaceWith(Other,"goChristmasLights.XmasArmor");
   		return false;
		}
		if(Other.Class==Class'JumpBoots')
		{
   		ReplaceWith(Other,"goChristmasLights.XmasJumpboots");
   		return false;
		}
		if(Other.Class==Class'Invisibility')
		{
   		ReplaceWith(Other,"goChristmasLights.XmasThighPads");
   		return false;
		}
		if (Other.Class==Class'Amplifier')
		{
			ReplaceWith(Other,"goChristmasLights.XmasUDamage");
			return false;
		}
		if (Other.Class==Class'SCUBAGear')
		{
			ReplaceWith(Other,"goChristmasLights.XmasScuba");
			return false;
		}
		if (Other.Class==Class'KevlarSuit')
		{
			ReplaceWith(Other,"goChristmasLights.XmasKevlar");
			return false;
		}
		if (Other.Class==Class'ToxinSuit')
		{
			ReplaceWith(Other,"goChristmasLights.XmasToxin");
			return false;
		}
		if (Other.Class==Class'AsbestosSuit')
		{
			ReplaceWith(Other,"goChristmasLights.XmasAsbestos");
			return false;
		}
	}
	bSuperRelevant = 0;
	return true;
}

defaultproperties
{
   SpawnAtInventoryOnly=True
   lightSize=0.20
   LightHeight=5
   UseItemReplacements=True
   UseChristmasTitan=false
	UseSnowTitan=false
	UseBothTitans=true
}
